<?php
$dir = $argv[1];
$files = array("Core.lua", "StatusAuras.lua", "StatusHealth.lua", "StatusUnitInfo.lua", "StatusNotTargetable.lua", "StatusRange.lua", "ProximoGridFrame.lua", "StatusTarget.lua", "StatusCastingSpell.lua", "ProximoGridIndicator.lua", "Indicators.lua");
$output_file = "locales/ProximoGrid-%s.lua";
$ouptput_languages = array(
	0 => "enUS",
	1 => "deDE",
	2 => "esES",
	3 => "frFR",
	4 => "koKR",
	5 => "ruRU",
	6 => "zhCN",
	7 => "zhTW"
);
	
$cache = array();
$tmp_string_top = "";
$tmp_string_top = <<< OUTPUT
local L = LibStub("AceLocale-3.0"):NewLocale("ProximoGrid", "%s", %s)
if L then
OUTPUT;
$tmp_string = "";
$tmp_string_false = "";
foreach ($files as $number => $filename) {
	$tmp_string .= "\n--$filename\n";
	$tmp_string_false .= "\n--$filename\n";
	$filename = "$dir/$filename";
	$handle = fopen($filename, "r");
	$content = fread($handle, filesize($filename));
	fclose($handle);
	preg_match_all("/L\[(\"?.*?\"?)\]/", $content, $matches, PREG_SET_ORDER);
	$strings = array();
	foreach ($matches as $val) {
		if (!isset($cache[$val[1]])) {
			if ($val[1] == "v.type") {
				$tmp_string .= "L[\"buff\"] = \"buff\""."\n";
				$tmp_string .= "L[\"debuff\"] = \"debuff\""."\n";
				$tmp_string_false .= "L[\"buff\"] = false"."\n";
				$tmp_string_false .= "L[\"debuff\"] = false"."\n";
			} else {
				$tmp_string .= "L[".$val[1]."] = ".$val[1].""."\n";
				$tmp_string_false .= "L[".$val[1]."] = false"."\n";
				$cache[$val[1]] = "true";
			}
		}
	}
}

$tmp_string .= <<< OUTPUT
end
OUTPUT;
$tmp_string_false .= <<< OUTPUT
end
OUTPUT;
foreach ($ouptput_languages as $number => $language) {
	$handle = fopen(sprintf("$output_file", $language) , 'w');
	$tmp_str = sprintf($tmp_string_top, $language, (($number==0)?"true":"false"));
	fwrite($handle, $tmp_str, strlen($tmp_str));
	if ($number==0) {
		fwrite($handle, $tmp_string, strlen($tmp_string));
	} else {
		fwrite($handle, $tmp_string_false, strlen($tmp_string_false));
	}
	fclose($handle);
}

?>